ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/deliantra/server/utils/cfutil.in
(Generate patch)

Comparing deliantra/server/utils/cfutil.in (file contents):
Revision 1.11 by root, Mon Mar 12 14:55:43 2007 UTC vs.
Revision 1.87 by root, Tue Oct 5 23:25:25 2010 UTC

1#!@PERL@ 1#!@PERL@
2 2
3use strict; 3#
4# This file is part of Deliantra, the Roguelike Realtime MMORPG.
5#
6# Copyright (©) 2007,2008,2009 Marc Alexander Lehmann / Robin Redeker / the Deliantra team
7#
8# Deliantra is free software: you can redistribute it and/or modify it under
9# the terms of the Affero GNU General Public License as published by the
10# Free Software Foundation, either version 3 of the License, or (at your
11# option) any later version.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the Affero GNU General Public License
19# and the GNU General Public License along with this program. If not, see
20# <http://www.gnu.org/licenses/>.
21#
22# The authors can be reached via e-mail to <support@deliantra.net>
23#
24
25use common::sense;
4 26
5my $prefix = "@prefix@"; 27my $prefix = "@prefix@";
6my $exec_prefix = "@exec_prefix@"; 28my $exec_prefix = "@exec_prefix@";
7my $datarootdir = "@datarootdir@"; 29my $datarootdir = "@datarootdir@";
8my $DATADIR = "@datadir@/@PACKAGE@"; 30my $DATADIR = "@datadir@/@PACKAGE@";
9 31
10my $CONVERT = "@CONVERT@"; 32my $CONVERT = "@CONVERT@";
11my $IDENTIFY = "@IDENTIFY@"; 33#my $IDENTIFY = "@IDENTIFY@";
12my $OPTIPNG = "@OPTIPNG@"; 34my $OPTIPNG = "@OPTIPNG@";
13my $RSYNC = "@RSYNC@"; 35my $RSYNC = "@RSYNC@";
36my $PNGNQ = "@PNGNQ@";
14 37
15use Getopt::Long; 38use Getopt::Long;
39use File::Temp;
40use POSIX ();
41use Carp;
42
16use Coro::Event; 43use Coro::EV;
17use AnyEvent; 44use AnyEvent;
45use YAML::XS ();
46use JSON::XS ();
18use IO::AIO (); 47use IO::AIO ();
19use File::Temp; 48use Digest::MD5 ();
20use Crossfire; 49
21use Coro; 50use Coro 5.12;
22use Coro::AIO; 51use Coro::AIO;
23use POSIX (); 52use Coro::Util;
24use Digest::MD5; 53use Coro::Channel;
54use Coro::Storable; $Storable::canonical = 1;
55
56use Deliantra;
57
58$SIG{QUIT} = sub { Carp::cluck "QUIT" };
25 59
26sub usage { 60sub usage {
27 warn <<EOF; 61 warn <<EOF;
28Usage: cfutil [-v] [-q] [--force] [--cache] 62Usage: cfutil [-v] [-q] [--force] [--cache]
29 [--install-arch path] 63 [--install-arch path]
40my $VERBOSE = 1; 74my $VERBOSE = 1;
41my $CACHE = 0; 75my $CACHE = 0;
42my $FORCE; 76my $FORCE;
43my $TMPDIR = "/tmp/cfutil$$~"; 77my $TMPDIR = "/tmp/cfutil$$~";
44my $TMPFILE = "aaaa0"; 78my $TMPFILE = "aaaa0";
79my @COMMIT;
80
81our %COLOR = (
82 black => 0,
83 white => 1,
84 navy => 2,
85 red => 3,
86 orange => 4,
87 blue => 5,
88 darkorange => 6,
89 green => 7,
90 lightgreen => 8,
91 grey => 9,
92 brown => 10,
93 gold => 11,
94 tan => 12,
95);
45 96
46END { system "rm", "-rf", $TMPDIR } 97END { system "rm", "-rf", $TMPDIR }
47 98
48Event->signal (signal => "INT", cb => sub { exit 1 }); 99my $s_INT = EV::signal INT => sub { exit 1 };
49Event->signal (signal => "TERM", cb => sub { exit 1 }); 100my $s_TERM = EV::signal TERM => sub { exit 1 };
101
102our %hash;
103
104# here we could try to avoid collisions and reduce chksum size further
105sub make_hash($\$\$;$) {
106 my ($id, $dataref, $hashref, $clen) = @_;
107
108 my $hash = substr +(Digest::MD5::md5 $$dataref), 0, $clen || 4;
109
110 if (exists $hash{$hash}) {
111 # hahs collinion, but some files are simply identical
112 if (${$hash{$hash}[1]} ne $$dataref) {
113 warn "hash collision $hash{$hash}[0] vs. $id\n";
114 exit 1;
115 } else {
116 print "$hash{$hash}[0] and $id are identical (which is fine).\n" if $VERBOSE >= 3;
117 }
118 }
119 $hash{$hash} = [$id, $dataref, $hashref];
120
121 $$hashref = $hash;
122}
50 123
51mkdir $TMPDIR, 0700 124mkdir $TMPDIR, 0700
52 or die "$TMPDIR: $!"; 125 or die "$TMPDIR: $!";
53 126
54sub fork_sub(&) { 127sub fork_sub(&) {
67} 140}
68 141
69sub inst_maps($) { 142sub inst_maps($) {
70 my (undef, $path) = @_; 143 my (undef, $path) = @_;
71 144
72 print "installing '$path' to '$DATADIR/maps'\n\n"; 145 print "\nInstalling '$path' to '$DATADIR/maps'\n\n";
73 146
74 if (!-f "$path/regions") { 147 if (!-f "$path/regions") {
75 warn "'$path' does not look like a maps directory ('regions' file is missing).\n"; 148 warn "'$path' does not look like a maps directory ('regions' file is missing).\n";
76 exit 1 unless $FORCE; 149 exit 1 unless $FORCE;
77 } 150 }
78 151
79 system $RSYNC, "-av", "$path/.", "$DATADIR/maps/.", "--delete", "--exclude", "CVS", "--delete-excluded"; 152 system $RSYNC, "-av", "--chmod=u=rwX,go=rX",
153 "$path/.", "$DATADIR/maps/.",
154 "--exclude", "CVS", "--exclude", "/world-precomposed",
155 "--delete", "--delete-excluded"
156 and die "map installation failed.\n";
157
158 print "maps installed successfully.\n";
80} 159}
81 160
161sub autoglyph {
162 my ($stem, $face) = @_;
163
164 if ($stem =~ /^wall\/|Nimwall/) {
165# warn $stem;
166 "+"
167 } elsif ($stem =~ /^floor\/|^ground\/|Nimfloor/) {
168 "."
169 } else {
170 substr $stem, 0, 1
171 }
172}
173
82{ 174{
83 our %PNG32; 175 our %ANIMINFO;
84 our %FACEINFO; 176 our %FACEINFO;
177 our %RESOURCE;
85 our @ARC; 178 our @ARC;
179 our %ARC;
180 our $TRS;
86 our $NFILE; 181 our $NFILE;
87 our %ANIM; 182 our $PATH;
88 183
89 our (@png, @trs, @arc); # files we are interested in 184 our $QUANTIZE = "+dither -colorspace RGB -colors 256";
90 185
186 our $c_arc = new Coro::Channel;
187 our $c_trs = new Coro::Channel;
188 our $c_res = new Coro::Channel;
189
190 our @c_png;
191
91 sub commit_png { 192 sub commit_png($$$$) {
92 my ($name, $data) = @_; 193 my ($stem, $name, $data, $T) = @_;
93 194
94 $PNG32{$name} = $data; 195 $FACEINFO{$name}{"stem"} = substr $stem, 1 + length $PATH;
95 $FACEINFO{$name} ||= {}; 196 $FACEINFO{$name}{"data$T"} = $data;
96 } 197 }
97 198
98 sub process_png { 199 sub process_png {
99 while (@png) { 200 while (@c_png) {
100 my $path = pop @png; 201 my ($path, $delete) = @{pop @c_png};
101 202
102 my $png; 203 my $png;
103 aio_lstat $path; 204 aio_lstat $path;
104 my ($size, $mtime) = (stat _)[7,9]; 205 my ($size, $mtime) = (stat _)[7,9];
105 206
106 if (0 > aio_load $path, $png) { 207 if (0 > aio_load $path, $png) {
107 warn "$path: $!, skipping.\n"; 208 warn "$path: $!, skipping.\n";
108 next; 209 next;
109 } 210 }
110 211
212 my $stem = $path;
213 my $T;
214
215 if ($stem =~ s/\.32x32\.png~?$//) {
216 $T = 32;
217 } elsif ($stem =~ s/\.64x64\.png~?$//) {
218 $T = 64;
219 } else {
220 warn "$path: weird filename, skipping.\n";
221 next;
222 }
223
111 # quickly extract width and height of the (necessarily PNG) image 224 # quickly extract width and height of the (necessarily PNG) image
112 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) { 225 unless ($png =~ /^\x89PNG\x0d\x0a\x1a\x0a....IHDR(........)/s) {
113 warn "$path: not a recongized png file, skipping.\n"; 226 warn "$path: not a recognized png file, skipping.\n";
114 next; 227 next;
115 } 228 }
116 229
117 my ($w, $h) = unpack "NN", $1; 230 my ($w, $h) = unpack "NN", $1;
118
119 (my $face = $path) =~ s/^.*\///;
120 my $T = 32;
121
122 unless ($face =~ s/\.base\.(...)\.png$/.$1/) {
123 warn "$path: weird filename, skipping.\n";
124 next;
125 }
126 231
127 if ($w < $T || $h < $T) { 232 if ($w < $T || $h < $T) {
128 warn "$path: too small ($w $h), skipping.\n"; 233 warn "$path: too small ($w $h), skipping.\n";
129 next; 234 next;
130 } 235 }
132 if ($w % $T || $h % $T) { 237 if ($w % $T || $h % $T) {
133 warn "$path: weird png size ($w $h), skipping.\n"; 238 warn "$path: weird png size ($w $h), skipping.\n";
134 next; 239 next;
135 } 240 }
136 241
242 (my $base = $stem) =~ s/^.*\///;
243
244 my $fi = $FACEINFO{$base};
245 unless ($fi) {
246 #warn "$path: <$base> not referenced by any archetype, skipping.\n";
247 #next;
248 }
249
250 my $arc = $fi->{arc} || { };
251
252 unless ($path =~ /~$/) {
253 # possibly enlarge
254 if (0 > aio_stat "$stem.64x64.png") {
255 my $other = "$stem.64x64.png~";
256
257 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
258 fork_sub {
259 my $CROP;
260 my $SRC = "png:\Q$path\E";
261
262 my $is_floor = $arc->{is_floor};
263 my $is_wall = 0;
264
265 my ($wall_pfx, $wall_dir, $wall_sfx);
266
267 if (
268 !$is_floor
269 && !$arc->{alive}
270 && $arc->{move_block} eq "all"
271 && $path =~ /^(.*_)([0-9A-F])(\.x11.*\.png)$/
272 ) {
273 ($wall_pfx, $wall_dir, $wall_sfx) = ($1, hex $2, $3);
274
275 unless (grep { !-e sprintf "%s%X%s", $wall_pfx, $_, $wall_sfx } 0..15) {
276 $is_wall = 1;
277 }
278 }
279
280 if ($is_wall || $is_floor) {
281 # add a 4px border and add other images around it
282 $CROP = "-shave 8x8 +repage";
283
284 $w += 8;
285 $h += 8;
286
287 $SRC = "-size ${w}x${h} xc:transparent";
288 $SRC .= " png:\Q$path\E -geometry +4+4 -composite";
289
290 # 8 surrounding images
291 for (
292 # x y b r0 r1
293 [-1, -1, 0, 6],
294 [ 0, -1, 1, 10, 14],
295 [+1, -1, 0, 12],
296
297 [-1, 0, 8, 5, 7],
298 #
299 [+1, 0, 2, 5, 13],
300
301 [-1, +1, 0, 3],
302 [ 0, +1, 4, 10, 11],
303 [+1, +1, 0, 9],
304 ) {
305 my ($x, $y, $d, $r0, $r1) = @$_;
306
307 my $tile = $is_floor ? $path
308 : $is_wall ? sprintf "%s%X%s", $wall_pfx, ($wall_dir & $d) ? $r1 : $r0, $wall_sfx
309 : die;
310
311 $SRC .= sprintf " png:%s -geometry %+d%+d -composite",
312 "\Q$tile",
313 $x * ($w - 8) + 4,
314 $y * ($h - 8) + 4;
315 }
316 }
317
318 system "convert -depth 8 $SRC rgba:-"
319 . "| $exec_prefix/bin/cfhq2xa $w $h 0"
320 . "| convert -depth 8 -size ".($w * 2)."x".($h * 2)." rgba:- $CROP $QUANTIZE -quality 00 png32:\Q$other\E~"
321 and die "convert/cfhq2xa pipeline error: status $? ($!)";
322 system $OPTIPNG, "-i0", "-q", "$other~";
323 die "$other~ has zero size, aborting." unless -s "$other~";
324 rename "$other~", $other;
325 };
326 }
327
328 push @c_png, [$other, !$CACHE];
329 }
330
331 # possibly scale down
332 if (0 > aio_stat "$stem.32x32.png") {
333 my $other = "$stem.32x32.png~";
334
335 if (0 > aio_lstat $other or (-M _) > (-M $path)) {
336 fork_sub {
337 system "convert png:\Q$path\E -geometry 50% -filter lanczos $QUANTIZE -quality 00 png32:\Q$other\E~";
338 system $OPTIPNG, "-i0", "-q", "$other~";
339
340 # reduce smoothfaces >10000 bytes
341 # obsolete, no longer required
342 if (0 && $stem =~ /_S\./ && (-s "$other~") > 10000) {
343 my $ncolor = 256;
344 while () {
345 system "<\Q$other~\E $PNGNQ -s1 -n$ncolor >\Q$other~~\E";
346 system $OPTIPNG, "-i0", "-q", "$other~~";
347 last if 10000 > -s "$other~~";
348 $ncolor = int $ncolor * 0.9;
349 $ncolor > 8 or die "cannot reduce filesize to < 10000 bytes";
350 }
351
352 printf "reduced %s from %d to %d bytes using %d colours.\n",
353 $other, -s "$other~", -s "$other~~", $ncolor
354 if $VERBOSE >= 2;
355 rename "$other~~", "$other~";
356 }
357
358 die "$other~ has zero size, aborting." unless -s "$other~";
359 rename "$other~", $other;
360 };
361 }
362
363 #warn "scaled down $path to $other\n";#d#
364 push @c_png, [$other, !$CACHE];
365 }
366 }
367
368 (my $face = $stem) =~ s/^.*\///;
369
370 # split all bigfaces, but avoid smoothfaces (*_S)
137 if (($w > $T || $h > $T) && $face !~ /_S\./) { 371 if (($w > $T || $h > $T) && $face !~ /_S\./) {
138 # split 372 # split
139 my @tile; 373 my @tile;
140 for my $x (0 .. (int $w / $T) - 1) { 374 for my $x (0 .. (int $w / $T) - 1) {
141 for my $y (0 .. (int $h / $T) - 1) { 375 for my $y (0 .. (int $h / $T) - 1) {
155 ( 389 (
156 "(", 390 "(",
157 "+clone", 391 "+clone",
158 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T), 392 -crop => (sprintf "%dx%d+%d+%d", $T, $T, $_->[0] * $T, $_->[1] * $T),
159 "+repage", 393 "+repage",
394 -quality => "00",
160 -write => "png:$_->[2]~", 395 -write => "png32:$_->[2]~",
161 "+delete", 396 "+delete",
162 ")", 397 ")",
163 ) 398 )
164 } @todo), 399 } @todo),
165 "null:"; 400 "null:";
169 close $convert; 404 close $convert;
170 405
171 # pass 2, optimise, and rename 406 # pass 2, optimise, and rename
172 for (@todo) { 407 for (@todo) {
173 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~"; 408 system $OPTIPNG, "-o5", "-i0", "-q", "$_->[2]~";
409 die "$_->[2]~ has zero size, aborting." unless -s "$_->[2]~";
174 rename "$_->[2]~", $_->[2]; 410 rename "$_->[2]~", $_->[2];
175 } 411 }
176 }; 412 };
177 } 413 }
178 414
182 418
183 if (0 > aio_load $file, $tile) { 419 if (0 > aio_load $file, $tile) {
184 die "$path: unable to read tile +$x+$y, aborting.\n"; 420 die "$path: unable to read tile +$x+$y, aborting.\n";
185 } 421 }
186 IO::AIO::aio_unlink $file unless $CACHE; 422 IO::AIO::aio_unlink $file unless $CACHE;
187 commit_png $x|$y ? "$face+$x+$y" : $face, $tile; 423 commit_png $stem, $x|$y ? "$face+$x+$y" : $face, $tile, $T;
188 } 424 }
189 } else { 425 } else {
190 # use as-is (either small, use smooth) 426 # use as-is (either small, use smooth)
191 commit_png $face, $png; 427 commit_png $stem, $face, $png, $T;
192 } 428 }
429
430 aio_unlink $path if $delete;
193 } 431 }
194 } 432 }
195 433
196 sub process_arc { 434 sub process_arc {
197 while (@arc) { 435 while (my $job = $c_arc->get) {
198 my ($dir, $file) = @{pop @arc}; 436 my ($dir, $file) = @$job;
199 437
200 my $arc; 438 my $arc;
201 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/ 439 aio_load "$dir/$file", $arc; # simply pre-cache, as read_arch wants a file :/
202 440
203 my $arc = read_arch "$dir/$file"; 441 my $arc = read_arch "$dir/$file";
204 for my $o (values %$arc) { 442 for my $o (values %$arc) {
205 push @ARC, $o; 443 push @ARC, $o;
444 for (my $m = $o; $m; $m = $m->{more}) {
445 $ARC{$m->{_name}} = $m;
446 }
206 447
207 $o->{editor_folder} = $dir; 448 $o->{editor_folder} ||= "\x00$dir"; # horrible kludge
208 449
209 my $visibility = delete $o->{visibility}; 450 my $visibility = delete $o->{visibility};
210 my $magicmap = delete $o->{magicmap}; 451 my $magicmap = delete $o->{magicmap};
452 my $glyph = delete $o->{glyph};
211 453
212 # find upper left corner :/ 454 # find upper left corner :/
213 # omg, this is sooo broken 455 # omg, this is sooo broken
214 my ($dx, $dy); 456 my ($dx, $dy);
215 for (my $o = $o; $o; $o = $o->{more}) { 457 for (my $o = $o; $o; $o = $o->{more}) {
221 my $x = $o->{x} - $dx; 463 my $x = $o->{x} - $dx;
222 my $y = $o->{y} - $dy; 464 my $y = $o->{y} - $dy;
223 465
224 my $ext = $x|$y ? "+$x+$y" : ""; 466 my $ext = $x|$y ? "+$x+$y" : "";
225 467
226 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/; 468 $o->{face} .= $ext unless /^blank.x11$|^empty.x11$/ || !$o->{face};
227 469
228 my $visibility = delete $o->{visibility} if exists $o->{visibility}; 470 $visibility = delete $o->{visibility} if exists $o->{visibility};
229 my $magicmap = delete $o->{magicmap} if exists $o->{magicmap}; 471 $magicmap = delete $o->{magicmap} if exists $o->{magicmap};
472 $glyph = delete $o->{glyph} if exists $o->{glyph};
230 473
231 my $anim = delete $o->{anim}; 474 my $anim = delete $o->{anim};
232 475
233 if ($anim) { 476 if ($anim) {
477 # possibly add $ext to the animation name to avoid
478 # the need to specify archnames for all parts
479 # of a multipart archetype.
234 $o->{animation} = "$o->{_name}"; 480 $o->{animation} = "$o->{_name}";
481 my $facings = 1;
482 my @frames;
235 483
236 for (@$anim) { 484 for (@$anim) {
237 $_ .= $ext unless /^facings\s|^blank.x11$|^empty.x11$/; 485 if (/^facings\s+(\d+)/) {
486 $facings = $1*1;
487 } elsif (/^blank.x11$|^empty.x11$/) {
488 push @frames, $_;
489 } else {
490 push @frames, "$_$ext";
491 }
238 } 492 }
239 493
240 $ANIM{"$o->{_name}$ext"} = 494 $ANIMINFO{$o->{animation}} = {
241 join "", map "$_\n", 495 facings => $facings,
242 "anim $o->{_name}", 496 frames => \@frames,
243 @$anim, 497 };
244 "mina";
245 } 498 }
246 499
247 for my $face ($o->{face} || (), @{$anim || []}) { 500 for ($o->{face} || (), @{$anim || []}) {
248 next if $face =~ /^facings\s|^blank.x11$|^empty.x11$/; 501 next if /^facings\s/;
249 502
503 my $face = $_;
504 $face =~ s/\+\d+\+\d+$//; # remove tile offset coordinates
505
250 my $info = $FACEINFO{$face} ||= {}; 506 my $info = $FACEINFO{$face} ||= { };
507 $info->{arc} = $o;
508
509 next if $face =~ /^blank.x11$|^empty.x11$/;
251 510
252 $info->{visibility} = $visibility if defined $visibility; 511 $info->{visibility} = $visibility if defined $visibility;
253 $info->{magicmap} = $magicmap if defined $magicmap; 512 $info->{magicmap} = $magicmap if defined $magicmap;
513 $info->{glyph} = $glyph if defined $glyph;
254 } 514 }
515
516 if (my $smooth = delete $o->{smoothface}) {
517 my %kv = split /\s+/, $smooth;
518 my $level = $o->{smoothlevel}; #TODO: delete from $o if !gcfclient-support
519 while (my ($face, $smooth) = each %kv) {
520 $FACEINFO{$smooth}{arc} = $o;
521
522 $FACEINFO{$face}{smooth} = $smooth;
523 $FACEINFO{$face}{smoothlevel} = $level;
524 }
525 }
255 } 526 }
256 } 527 }
257 } 528 }
258 } 529 }
259 530
260 sub process_trs { 531 sub process_trs {
261 while (@trs) { 532 while (my $job = $c_trs->get) {
262 my ($dir, $file) = @{pop @trs}; 533 my ($dir, $file) = @$job;
534 my $path = "$dir/$file";
535
536 my $trs;
537 if (0 > aio_load $path, $trs) {
538 warn "$path: $!, skipping.\n";
539 next;
540 }
541
542 $TRS .= $trs;
543 }
544 }
545
546 my %FILECACHE;
547
548 sub load_cached($;$) {
549 unless (exists $FILECACHE{$_[0]}) {
550 my $data;
551 if (0 < aio_load $_[0], $data) {
552 if ($_[1]) {
553 $data = eval { $_[1]->($data) };
554 warn "$_[0]: $@" if $@;
555 }
556 }
557
558 $FILECACHE{$_[0]} = $data;
559 }
560
561 $FILECACHE{$_[0]}
562 }
563
564 sub process_res {
565 while (my $job = $c_res->get) {
566 my ($dir, $file, $type) = @$job;
567
568 my $data;
569 aio_load "$dir/$file", $data;
570
571 my $meta = load_cached "$dir/meta", sub { JSON::XS->new->utf8->relaxed->decode (shift) };
572
573 utf8::decode $dir;
574 utf8::decode $file;
575
576 # a meta file for resources is now mandatory
577 unless (exists $meta->{$file}) {
578 warn "skipping $dir/$file\n" if $VERBOSE >= 3;
579 next;
580 }
581
582 $meta = {
583 %{ $meta->{"" } || {} },
584 %{ $meta->{$file} || {} },
585 };
586
587 if ($meta->{license} =~ s/^#//) {
588 $meta->{license} = ({
589 "pd" => "Public Domain",
590 "gpl" => "GNU General Public License, version 3.0 or any later",
591 "cc/by/2.0" => "Licensed under Creative Commons Attribution 2.0 http://creativecommons.org/licenses/by/2.0/",
592 "cc/by/2.1" => "Licensed under Creative Commons Attribution 2.1 http://creativecommons.org/licenses/by/2.1/",
593 "cc/by/2.5" => "Licensed under Creative Commons Attribution 2.5 http://creativecommons.org/licenses/by/2.5/",
594 "cc/by/3.0" => "Licensed under Creative Commons Attribution 3.0 http://creativecommons.org/licenses/by/3.0/",
595 })->{$meta->{license}}
596 || warn "$dir/$file: license tag '$meta->{license}' not found.";
597 }
598
599 if (!exists $meta->{author} && $meta->{source} =~ m%^http://www.jamendo.com/en/artist/(.*)$%) {
600 ($meta->{author} = $1) =~ s/_/ /g;
601 }
602
603 $file =~ s/\.res$//;
604 $file =~ s/\.(ogg|wav|jpg|png)$//;
605
606 substr $dir, 0, 1 + length $PATH, "";
607
608 if (my $filter = $meta->{cfutil_filter}) {
609 if ($filter eq "yaml2json") {
610 $data = JSON::XS::encode_json YAML::XS::Load $data;
611 } elsif ($filter eq "json2json") {
612 $data = JSON::XS::encode_json JSON::XS->relaxed->utf8->decode ($data);
613 } elsif ($filter eq "perl2json") {
614 $data = eval $data; die if $@;
615 $data = JSON::XS::encode_json $data;
616 } else {
617 warn "$dir/$file: unknown filter $filter, skipping\n";
618 }
619 }
620
621 $RESOURCE{"$dir/$file"} = {
622 type => (exists $meta->{type} ? delete $meta->{type} : $type),
623 data => $data,
624 %$meta ? (meta => $meta) : (),
625 };
263 } 626 }
264 } 627 }
265 628
266 sub find_files; 629 sub find_files;
267 sub find_files { 630 sub find_files {
270 IO::AIO::aioreq_pri 4; 633 IO::AIO::aioreq_pri 4;
271 IO::AIO::aio_scandir $path, 4, sub { 634 IO::AIO::aio_scandir $path, 4, sub {
272 my ($dirs, $nondirs) = @_; 635 my ($dirs, $nondirs) = @_;
273 636
274 find_files "$path/$_" 637 find_files "$path/$_"
275 for grep $_ !~ /^(?:CVS|dev)$/, @$dirs; 638 for grep $_ !~ /^(?:CVS|dev|\..*)$/, @$dirs;
639
640 my $dir = $path;
641 substr $dir, 0, 1 + length $PATH, "";
276 642
277 for my $file (@$nondirs) { 643 for my $file (@$nondirs) {
644 if ($dir =~ /^music(?:\/|$)/) {
645 $c_res->put ([$path, $file, 3]) # FT_MUSIC
646 if $file =~ /\.(ogg)$/;
647
648 } elsif ($dir =~ /^sound(?:\/|$)/) {
649 $c_res->put ([$path, $file, 5]) # FT_SOUND
650 if $file =~ /\.(wav|ogg)$/;
651
652 } elsif ($dir =~ /^res(?:\/|$)/) {
653 if ($file =~ /\.(jpg|png)$/) {
654 $c_res->put ([$path, $file, 0]) # FT_FACE
655 } elsif ($file =~ /\.(res)$/) {
656 $c_res->put ([$path, $file, 6]) # FT_RSRC
657 } else {
658 $c_res->put ([$path, $file, undef]);
659 }
660
278 if ($file =~ /\.png$/) { 661 } elsif ($file =~ /\.png$/) {
279 push @png, "$path/$file"; 662 push @c_png, ["$path/$file", 0];
663
280 } elsif ($file =~ /\.trs$/) { 664 } elsif ($file =~ /\.trs$/) {
281 push @trs, [$path, $file]; 665 $c_trs->put ([$path, $file]);
666
282 } elsif ($file =~ /\.arc$/) { 667 } elsif ($file =~ /\.arc$/) {
283 push @arc, [$path, $file]; 668 $c_arc->put ([$path, $file]);
669
284 } else { 670 } else {
285 warn "ignoring $path/$file\n" if $VERBOSE >= 2; 671 warn "ignoring $path/$file\n" if $VERBOSE >= 3;
286 } 672 }
287 } 673 }
288 }; 674 };
675 }
676
677 sub generate_plurals {
678# use Lingua::EN::Inflect ();
679# Lingua::EN::Inflect::classical;
680# Lingua::EN::Inflect::def_noun '(.*)staff' => '$1staves'; # policy
681# Lingua::EN::Inflect::def_noun '(.*)boots' => '$1boots'; # hack
682#
683# for my $a (@ARC) {
684# my $name = $a->{name} || $a->{_name};
685#
686# next unless $a->{name_pl};
687# next if $a->{invisible};
688# next if $a->{is_floor};
689# next if $a->{no_pick};
690#
691# my $test = Lingua::EN::Inflect::PL_N_eq $name, Lingua::EN::Inflect::PL $name;
692# my $pl = $test =~ /^(?:eq|p:.)$/
693# ? $name
694# : Lingua::EN::Inflect::PL $name;
695#
696# if ($pl ne $a->{name_pl}) {
697# warn "$a->{_name}: plural differs, $pl vs $a->{name_pl}\n";
698# }
699# }
289 } 700 }
290 701
291 sub inst_arch($) { 702 sub inst_arch($) {
292 my (undef, $path) = @_; 703 my (undef, $path) = @_;
293 704
705 $PATH = $path;
706
707 print "\n",
294 print "installing '$path' to '$DATADIR'\n\n"; 708 "Installing '$path' to '$DATADIR'\n",
709 "\n",
710 "This can take a long time if you run this\n",
711 "for the first time or do not use --cache.\n",
712 "\n",
713 "Unless you run verbosely, all following warning\n",
714 "or error messages indicate serious problems.\n",
715 "\n";
295 716
296 if (!-d "$path/treasures") { 717 if (!-d "$path/treasures") {
297 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n"; 718 warn "'$path' does not look like an arch directory ('treasures' directory is missing).\n";
298 exit 1 unless $FORCE; 719 exit 1 unless $FORCE;
299 } 720 }
300 721
722 print "scanning files...\n" if $VERBOSE;
723
301 find_files $path; 724 find_files $path;
725
726 my @a_arc = map +(async \&process_arc), 1..2;
727 my @a_res = map +(async \&process_res), 1..2;
728 my @a_trs = map +(async \&process_trs), 1..2;
729
302 IO::AIO::flush; 730 IO::AIO::flush;
303 731
304 $_->join for ( 732 $c_res->shutdown;
305 (async \&process_png), (async \&process_png), 733 $c_arc->shutdown;
306 (async \&process_trs), (async \&process_trs), 734 $c_trs->shutdown;
307 (async \&process_arc), (async \&process_arc),
308 );
309 735
736 print "start file scan, arc, res processing...\n" if $VERBOSE;
737
738 $_->join for @a_arc; # need to parse all archetypes before png processing
739
740 print "end arc, start png processing...\n" if $VERBOSE;
741
742 # eight png crunchers work fine for my 4x smp machine
743 my @a_png = map +(async \&process_png), 1..8;
744
745 $_->join for (@a_trs, @a_res, @a_png);
746
747 print "scanning done, processing results...\n" if $VERBOSE;
310 { 748 {
311 open my $fh, ">:utf8", "$DATADIR/animations~" 749 # remove path prefix from editor_folder
312 or die "$DATADIR/animations~: $!"; 750 $_->{editor_folder} =~ /^\x00/
313 print $fh join "", map $ANIM{$_}, sort keys %ANIM 751 and substr $_->{editor_folder}, 0, 2 + length $path, ""
752 for values %ARC;
753
754 print "resolving inheritance tree...\n" if $VERBOSE;
755 # resolve inherit
756 while () {
757 my $progress;
758 my $loop;
759
760 for my $o (values %ARC) {
761 for my $other (split /,/, $o->{inherit}) {
762 if (my $s = $ARC{$other}) {
763 if ($s->{inherit}) {
764 $loop = $s;
765 } else {
766 delete $o->{inherit};
767 my %s = %$s;
768 delete @s{qw(_name more name name_pl)};
769 %$o = ( %s, %$o );
770 ++$progress;
771 }
772 } else {
773 warn "'$o->{_name}' tries to inherit from undefined archetype '$other', skipping.\n";
774 delete $ARC{$o->{_name}};
775 }
776 }
777 }
778
779 unless ($progress) {
780 die "inheritance loop detected starting at archetype '$loop->{_name}', aborting.\n"
781 if $loop;
782
783 last;
784 }
314 } 785 }
315 786
316 { 787 # remove base classes (by naming scheme, should use something like "baseclass xxx" to inherit
788 @ARC = grep $_->{_name} !~ /^(?:type|class)_/, @ARC;
789
790 print "generating plurals...\n" if $VERBOSE;
791 generate_plurals;
792
793 printf "writing %d archetypes...\n", scalar @ARC if $VERBOSE;
317 open my $fh, ">:utf8", "$DATADIR/archetypes~" 794 open my $fh, ">:utf8", "$DATADIR/archetypes~"
318 or die "$DATADIR/archetypes~: $!"; 795 or die "$DATADIR/archetypes~: $!";
319 substr $_->{editor_folder}, 0, 1 + length $path, "" for @ARC; 796 print $fh Deliantra::archlist_to_string [sort { $a->{_name} cmp $b->{_name} } @ARC];
320 print $fh Crossfire::archlist_to_string \@ARC;
321 } 797 }
322 798
323 { 799 {
800 printf "writing treasures (%d octets)...\n", length $TRS if $VERBOSE;
801 open my $fh, ">:utf8", "$DATADIR/treasures~"
802 or die "$DATADIR/treasures~: $!";
803 print $fh $TRS;
804 }
805
806 {
807 print "processing facedata...\n" if $VERBOSE;
324 while (my ($k, $v) = each %FACEINFO) { 808 while (my ($k, $v) = each %FACEINFO) {
325 $v->{data32} ||= delete $PNG32{$k}; 809 length $v->{data32} or warn "$k: face has no png32. this will not work (shoddy gcfclient will crash of course).\n";
810 length $v->{data64} or warn "$k: face has no png64. this will not work very well.\n";
811
812 make_hash $k, $v->{data32}, $v->{hash32};
813 make_hash $k, $v->{data64}, $v->{hash64};
814
815 #length $v->{data32} <= 10000 or warn "$k: face32 larger than 10000 bytes, will not work with crossfire client.\n";
816 #length $v->{data64} <= 10000 or warn "$k: face64 larger than 10000 bytes.\n";
817
818 my $stem = delete $v->{stem};
819 $v->{glyph} //= autoglyph $stem, $v;
820
821 if (my $magicmap = $v->{magicmap}) {
822 $magicmap =~ y/A-Z_\-/a-z/d;
823 $v->{magicmap} = $COLOR{$magicmap};
326 } 824 }
327 825
826 delete $v->{arc};
827 }
828
829 print "processing resources...\n" if $VERBOSE;
830 my $enc = JSON::XS->new->utf8->canonical->relaxed;
328 while (my ($k, $v) = each %FACEINFO) { 831 while (my ($k, $v) = each %RESOURCE) {
329 length $v->{data32} or warn "$k: face has no png32. this will crash the server.\n";
330 832
331 $v->{chksum32} = Digest::MD5::md5 $v->{data32}; 833 if ($v->{meta} && $v->{meta}{datadir}) {
834 delete $RESOURCE{$k};
835
836 $k =~ s/^res\/// or die "$k: datadir files must be in res/";
837
838 printf "writing $k (%d octets)...\n", length $v->{data} if $VERBOSE;
839 open my $fh, ">:raw", "$DATADIR/$k~"
840 or die "$DATADIR/$k~: $!";
841 syswrite $fh, $v->{data};
842 push @COMMIT, $k;
843
844 } else {
845 if ($v->{type} & 1) {
846 # prepend meta info
847
848 my $meta = $enc->encode ({
849 name => $k,
850 %{ $v->{meta} || {} },
851 });
852
853 $v->{data} = pack "(w/a*)*", $meta, $v->{data};
854 }
855
856 make_hash $k, $v->{data}, $v->{hash}, 6; # 6 for the benefit of existing clients
332 } 857 }
858 }
333 859
860 printf "writing facedata (%d faces, %d anims, %d resources)...\n",
861 scalar keys %FACEINFO,
862 scalar keys %ANIMINFO,
863 scalar keys %RESOURCE
864 if $VERBOSE;
865
334 open my $fh, ">:perlio", "$DATADIR/faces~" 866 open my $fh, ">:perlio", "$DATADIR/facedata~"
335 or die "$DATADIR/faces~: $!"; 867 or die "$DATADIR/facedata~: $!";
336 868
337 print $fh Storable::nfreeze \%FACEINFO; 869 print $fh nfreeze {
338 870 version => 2,
339 #use PApp::Util; warn PApp::Util::dumpval \%FACEINFO; 871 faceinfo => \%FACEINFO,
872 animinfo => \%ANIMINFO,
873 resource => \%RESOURCE,
340 } 874 };
341 875
342 for (qw(archetypes faces animations)) { 876 }
877
878 print "committing files...\n" if $VERBOSE;
879
880 for (qw(archetypes facedata treasures), @COMMIT) {
343 chmod 0644, "$DATADIR/$_~"; 881 chmod 0644, "$DATADIR/$_~";
344 rename "$DATADIR/$_~", "$DATADIR/$_"; 882 rename "$DATADIR/$_~", "$DATADIR/$_"
883 or die "$DATADIR/$_: $!";
345 } 884 }
346 885
347 die "--install-arch not fully implemented\n"; 886 print "archetype data installed successfully.\n";
348 } 887 }
349} 888}
350 889
351Getopt::Long::Configure ("bundling", "no_ignore_case"); 890Getopt::Long::Configure ("bundling", "no_ignore_case");
352GetOptions ( 891GetOptions (

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines